from attack_func import bike_attack
from multiprocessing import Process


tracefile_path = "/home/luke/CERG_BIKE_CPA_Traces" ## <--- update file path for your system

# Format: [security level, path to attempt directoy, input file name, trace file name, results directory path, log file name]
target_configs = [
    [1,f"{tracefile_path}/bike_l1_traces/attempt-01", "bike_dinFile_l1_seed_1.txt", "powerTraces.npy", f"{tracefile_path}/bike_l1_traces/attempt-01", "attack.log"],
    # [3,f"{tracefile_path}/bike_l3_traces/attempt-01", "bike_dinFile_l3_seed_1.txt", "powerTraces.npy", f"{tracefile_path}/bike_l3_traces/attempt-01", "attack.log"],
    # [5,f"{tracefile_path}/bike_l5_traces/attempt-01", "bike_dinFile_l5_seed_1.txt", "powerTraces.npy", f"{tracefile_path}/bike_l5_traces/attempt-01", "attack.log"],
]

## For running attacks in parallel (generally does not give much performance improvement since numpy parallelizes the calculations already)
NUM_THREADS = 1
thr_handles = [None]*NUM_THREADS


for i in range(len(target_configs)//NUM_THREADS):
    
    k = 0
    while(k < NUM_THREADS and (i*NUM_THREADS+k)<len(target_configs)):
        conf = target_configs[NUM_THREADS*i+k]
        thr_handles[k] = Process(target=bike_attack, args=(conf[0],conf[1],conf[2],conf[3],conf[4],conf[5]))
        k = k + 1

    
    k = 0
    while(k < NUM_THREADS and (i*NUM_THREADS+k)<len(target_configs)):
        thr_handles[k].start()
        k = k + 1

    k = 0
    while(k < NUM_THREADS and (i*NUM_THREADS+k)<len(target_configs)):
        thr_handles[k].join()
        k = k + 1





    
